#ifndef glas_dense_view_hpp
#define glas_dense_view_hpp

#include <glas/concept/is_dense_vector_expression.hpp>
#include <glas/view/sparse_dense_view.hpp>
#include <glas/view/sparse_strided_view.hpp>
#include <boost/mpl/if.hpp>

namespace glas {

template <class V>
struct dense_view_type
: boost::mpl::if_< is_dense_vector_expression< V >
                 , V&
                 , sparse_dense_view< V >
                 >
{} ;


template <class V>
inline typename dense_view_type<V>::type
dense_view( V& v ) 
{ return typename dense_view_type<V>::type( v ) ; }


}

#endif

